: # This is a generated 'bast' file. It is a combination of bash and batch,
: # and is runnable as both.
: <<BAST_HEADER
@echo off
goto batch_file
BAST_HEADER
#
#bash_file
#
rule=$1
if [ "$rule" == "" ]; then
  echo "Usage: build.sh.bat <rule>"
  echo "       Known rules: ['clean', 'package', 'chrome-signed', 'jar-signed', 'jar', 'unpacked', 'amo']"
  exit
elif [ "$rule" == "clean" ]; then
  rm -rf .build
  rm -rf output-result
  echo "Cleaned."
  exit
elif [ "$rule" == "package" ]; then
  for f in `git-ls-files`
    do mkdir -p .build/.package/paragrasp/$(dirname $f)
    cp $f .build/.package/paragrasp/$(dirname $f)
  done
  cp build.sh.bat .build/.package/paragrasp/.
  cd .build/.package
  tar czvf paragrasp.tgz paragrasp
  cd ../../
  rm -rf output-result
  mkdir output-result
  cd output-result
  ln -s ../.build/.package/paragrasp.tgz .
  cd ../
  echo "Packaged"
  exit
elif [ "$rule" == "clean" ]; then
  true
elif [ "$rule" == "package" ]; then
  true
elif [ "$rule" == "chrome-signed" ]; then
  true
elif [ "$rule" == "jar-signed" ]; then
  true
elif [ "$rule" == "jar" ]; then
  true
elif [ "$rule" == "unpacked" ]; then
  true
elif [ "$rule" == "amo" ]; then
  true
else
  echo "Unknown rule: $rule"
  echo "        Known rules: ['clean', 'package', 'chrome-signed', 'jar-signed', 'jar', 'unpacked', 'amo']"
  exit
fi
mkdir -p .build
ip=1000
while [ 1 ]; do
case $ip in
1000)
#
# Rule needs to be jar,amo,unpacked,jar-signed
#
if [ "$rule" == "jar" ]; then
  ip=1003
  continue
fi
if [ "$rule" == "amo" ]; then
  ip=1003
  continue
fi
if [ "$rule" == "unpacked" ]; then
  ip=1003
  continue
fi
if [ "$rule" == "jar-signed" ]; then
  ip=1003
  continue
fi
ip=1002
continue
ip=1003
;;
1003)
#
# Checking if js is newer than .build/jar
#
cd js
if ( find . -type f | xargs -I \$\$\$\$\$\$\$\$ test \$\$\$\$\$\$\$\$ -ot ../.build/jar/\$\$\$\$\$\$\$\$ ); then
  cd ../
else
  cd ../
  ip=1004
  continue
fi
#
# Jump
#
ip=1005
continue
#
# Label
#
ip=1004
;;
1004)
echo "Building \"jar/\""
mkdir -p .build/jar
cp -r js/* .build/jar/.
ip=1005
;;
1005)
ip=1002
;;
1002)
#
# Rule needs to be jar,amo,jar-signed
#
if [ "$rule" == "jar" ]; then
  ip=1007
  continue
fi
if [ "$rule" == "amo" ]; then
  ip=1007
  continue
fi
if [ "$rule" == "jar-signed" ]; then
  ip=1007
  continue
fi
ip=1006
continue
ip=1007
;;
1007)
#
# Checking if .build/jar is newer than .build/chrome/paragrasp.jar
#
if [ ! -f .build/chrome/paragrasp.jar ]; then
  ip=1008
  continue
elif [ "$(find .build/jar -type f -newer .build/chrome/paragrasp.jar)" != "" ]; then
  ip=1008
  continue
fi
#
# Jump
#
ip=1009
continue
#
# Label
#
ip=1008
;;
1008)
echo "Building \"chrome/paragrasp.jar\""
mkdir -p .build/chrome
cd .build/jar
zip -r -0 ../chrome/paragrasp.jar *
cd ../../
ip=1009
;;
1009)
#
# Checking if paragrasp.conf is newer than .build/chrome.manifest
#
if [ "`ls -t paragrasp.conf .build/chrome.manifest 2> /dev/null | sed 1q`" = "paragrasp.conf" ]; then
  ip=1010
  continue
fi
#
# Checking if firefox-template.manifest is newer than .build/chrome.manifest
#
if [ "`ls -t firefox-template.manifest .build/chrome.manifest 2> /dev/null | sed 1q`" = "firefox-template.manifest" ]; then
  ip=1010
  continue
fi
#
# Jump
#
ip=1011
continue
#
# Label
#
ip=1010
;;
1010)
echo "Building \"chrome.manifest\""
#
# Custom rule
#
python actions/create_manifest_action.py paragrasp.conf firefox-template.manifest -o .build/chrome.manifest -p jar
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1011
;;
1011)
ip=1006
;;
1006)
#
# Rule needs to be amo
#
if [ "$rule" != "amo" ]; then
  ip=1012
  continue
fi
#
# Checking if paragrasp.conf is newer than .build/install.rdf
#
if [ "`ls -t paragrasp.conf .build/install.rdf 2> /dev/null | sed 1q`" = "paragrasp.conf" ]; then
  ip=1013
  continue
fi
#
# Checking if firefox-template.rdf is newer than .build/install.rdf
#
if [ "`ls -t firefox-template.rdf .build/install.rdf 2> /dev/null | sed 1q`" = "firefox-template.rdf" ]; then
  ip=1013
  continue
fi
#
# Jump
#
ip=1014
continue
#
# Label
#
ip=1013
;;
1013)
echo "Building \"install.rdf\""
#
# Custom rule
#
python actions/create_manifest_action.py paragrasp.conf firefox-template.rdf -o .build/install.rdf -p no_update
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1014
;;
1014)
ip=1012
;;
1012)
#
# Rule needs to be unpacked
#
if [ "$rule" != "unpacked" ]; then
  ip=1015
  continue
fi
#
# Checking if .build/jar is newer than .build/chrome/paragrasp
#
cd .build/jar
if ( find . -type f | xargs -I \$\$\$\$\$\$\$\$ test \$\$\$\$\$\$\$\$ -ot ../chrome/paragrasp/\$\$\$\$\$\$\$\$ ); then
  cd ../../
else
  cd ../../
  ip=1016
  continue
fi
#
# Jump
#
ip=1017
continue
#
# Label
#
ip=1016
;;
1016)
echo "Building \"chrome/paragrasp/\""
mkdir -p .build/chrome/paragrasp
cp -r .build/jar/* .build/chrome/paragrasp/.
ip=1017
;;
1017)
#
# Checking if paragrasp.conf is newer than .build/chrome.manifest
#
if [ "`ls -t paragrasp.conf .build/chrome.manifest 2> /dev/null | sed 1q`" = "paragrasp.conf" ]; then
  ip=1018
  continue
fi
#
# Checking if firefox-template.manifest is newer than .build/chrome.manifest
#
if [ "`ls -t firefox-template.manifest .build/chrome.manifest 2> /dev/null | sed 1q`" = "firefox-template.manifest" ]; then
  ip=1018
  continue
fi
#
# Jump
#
ip=1019
continue
#
# Label
#
ip=1018
;;
1018)
echo "Building \"chrome.manifest\""
#
# Custom rule
#
python actions/create_manifest_action.py paragrasp.conf firefox-template.manifest -o .build/chrome.manifest -p unpacked
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1019
;;
1019)
ip=1015
;;
1015)
#
# Rule needs to be jar,unpacked,jar-signed
#
if [ "$rule" == "jar" ]; then
  ip=1021
  continue
fi
if [ "$rule" == "unpacked" ]; then
  ip=1021
  continue
fi
if [ "$rule" == "jar-signed" ]; then
  ip=1021
  continue
fi
ip=1020
continue
ip=1021
;;
1021)
#
# Checking if paragrasp.conf is newer than .build/install.rdf
#
if [ "`ls -t paragrasp.conf .build/install.rdf 2> /dev/null | sed 1q`" = "paragrasp.conf" ]; then
  ip=1022
  continue
fi
#
# Checking if firefox-template.rdf is newer than .build/install.rdf
#
if [ "`ls -t firefox-template.rdf .build/install.rdf 2> /dev/null | sed 1q`" = "firefox-template.rdf" ]; then
  ip=1022
  continue
fi
#
# Jump
#
ip=1023
continue
#
# Label
#
ip=1022
;;
1022)
echo "Building \"install.rdf\""
#
# Custom rule
#
python actions/create_manifest_action.py paragrasp.conf firefox-template.rdf -o .build/install.rdf -p jar
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1023
;;
1023)
ip=1020
;;
1020)
#
# Rule needs to be jar,amo,unpacked,jar-signed
#
if [ "$rule" == "jar" ]; then
  ip=1025
  continue
fi
if [ "$rule" == "amo" ]; then
  ip=1025
  continue
fi
if [ "$rule" == "unpacked" ]; then
  ip=1025
  continue
fi
if [ "$rule" == "jar-signed" ]; then
  ip=1025
  continue
fi
ip=1024
continue
ip=1025
;;
1025)
#
# Checking if preferences/paragrasp.js is newer than .build/defaults/preferences/paragrasp.js
#
if [ "`ls -t preferences/paragrasp.js .build/defaults/preferences/paragrasp.js 2> /dev/null | sed 1q`" = "preferences/paragrasp.js" ]; then
  ip=1026
  continue
fi
#
# Jump
#
ip=1027
continue
#
# Label
#
ip=1026
;;
1026)
echo "Building \"defaults/preferences/paragrasp.js\""
mkdir -p .build/defaults/preferences
cp preferences/paragrasp.js .build/defaults/preferences/paragrasp.js
ip=1027
;;
1027)
#
# Checking if .build/chrome is newer than .build/paragrasp.xpi
#
if [ ! -f .build/paragrasp.xpi ]; then
  ip=1028
  continue
elif [ "$(find .build/chrome -type f -newer .build/paragrasp.xpi)" != "" ]; then
  ip=1028
  continue
fi
#
# Checking if .build/chrome.manifest is newer than .build/paragrasp.xpi
#
if [ "`ls -t .build/chrome.manifest .build/paragrasp.xpi 2> /dev/null | sed 1q`" = ".build/chrome.manifest" ]; then
  ip=1028
  continue
fi
#
# Checking if .build/defaults is newer than .build/paragrasp.xpi
#
if [ ! -f .build/paragrasp.xpi ]; then
  ip=1028
  continue
elif [ "$(find .build/defaults -type f -newer .build/paragrasp.xpi)" != "" ]; then
  ip=1028
  continue
fi
#
# Checking if .build/install.rdf is newer than .build/paragrasp.xpi
#
if [ "`ls -t .build/install.rdf .build/paragrasp.xpi 2> /dev/null | sed 1q`" = ".build/install.rdf" ]; then
  ip=1028
  continue
fi
#
# Jump
#
ip=1029
continue
#
# Label
#
ip=1028
;;
1028)
echo "Building \"paragrasp.xpi\""
cd .build
zip -r -9 paragrasp.xpi chrome/ chrome.manifest defaults/ install.rdf
cd ..
ip=1029
;;
1029)
ip=1024
;;
1024)
#
# Rule needs to be jar,amo,unpacked
#
if [ "$rule" == "jar" ]; then
  ip=1031
  continue
fi
if [ "$rule" == "amo" ]; then
  ip=1031
  continue
fi
if [ "$rule" == "unpacked" ]; then
  ip=1031
  continue
fi
ip=1030
continue
ip=1031
;;
1031)
rm -rf output-result
mkdir output-result
cd output-result
ln ../.build/paragrasp.xpi paragrasp.xpi
cd ..
echo "Build completed!"
echo "Built output-result/paragrasp.xpi"
ip=1030
;;
1030)
#
# Rule needs to be jar-signed
#
if [ "$rule" != "jar-signed" ]; then
  ip=1032
  continue
fi
#
# Checking if paragrasp.conf is newer than .build/update-unsigned.rdf
#
if [ "`ls -t paragrasp.conf .build/update-unsigned.rdf 2> /dev/null | sed 1q`" = "paragrasp.conf" ]; then
  ip=1033
  continue
fi
#
# Checking if firefox-update-template.php is newer than .build/update-unsigned.rdf
#
if [ "`ls -t firefox-update-template.php .build/update-unsigned.rdf 2> /dev/null | sed 1q`" = "firefox-update-template.php" ]; then
  ip=1033
  continue
fi
#
# Checking if .build/paragrasp.xpi is newer than .build/update-unsigned.rdf
#
if [ "`ls -t .build/paragrasp.xpi .build/update-unsigned.rdf 2> /dev/null | sed 1q`" = ".build/paragrasp.xpi" ]; then
  ip=1033
  continue
fi
#
# Jump
#
ip=1034
continue
#
# Label
#
ip=1033
;;
1033)
echo "Building \"update-unsigned.rdf\""
#
# Custom rule
#
python actions/create_manifest_action.py paragrasp.conf firefox-update-template.php .build/paragrasp.xpi -o .build/update-unsigned.rdf -p hash
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1034
;;
1034)
#
# Checking if .build/update-unsigned.rdf is newer than .build/update.php
#
if [ "`ls -t .build/update-unsigned.rdf .build/update.php 2> /dev/null | sed 1q`" = ".build/update-unsigned.rdf" ]; then
  ip=1035
  continue
fi
#
# Checking if private/firefox.key.db is newer than .build/update.php
#
if [ "`ls -t private/firefox.key.db .build/update.php 2> /dev/null | sed 1q`" = "private/firefox.key.db" ]; then
  ip=1035
  continue
fi
#
# Jump
#
ip=1036
continue
#
# Label
#
ip=1035
;;
1035)
echo "Building \"update.php\""
#
# Custom rule
#
python actions/sign_with_mccoy.py .build/update-unsigned.rdf private/firefox.key.db -o .build/update.php
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1036
;;
1036)
rm -rf output-result
mkdir output-result
cd output-result
ln ../.build/update.php update.php
ln ../.build/paragrasp.xpi paragrasp.xpi
cd ..
echo "Build completed!"
echo "Built output-result/update.php"
echo "Built output-result/paragrasp.xpi"
ip=1032
;;
1032)
#
# Rule needs to be chrome-signed
#
if [ "$rule" != "chrome-signed" ]; then
  ip=1037
  continue
fi
#
# Checking if js/content/paragrasp.js is newer than .build/chromium/paragrasp.js
#
if [ "`ls -t js/content/paragrasp.js .build/chromium/paragrasp.js 2> /dev/null | sed 1q`" = "js/content/paragrasp.js" ]; then
  ip=1038
  continue
fi
#
# Jump
#
ip=1039
continue
#
# Label
#
ip=1038
;;
1038)
echo "Building \"chromium/paragrasp.js\""
mkdir -p .build/chromium
cp js/content/paragrasp.js .build/chromium/paragrasp.js
ip=1039
;;
1039)
#
# Checking if chromium-src is newer than .build/chromium
#
cd chromium-src
if ( find . -type f | xargs -I \$\$\$\$\$\$\$\$ test \$\$\$\$\$\$\$\$ -ot ../.build/chromium/\$\$\$\$\$\$\$\$ ); then
  cd ../
else
  cd ../
  ip=1040
  continue
fi
#
# Jump
#
ip=1041
continue
#
# Label
#
ip=1040
;;
1040)
echo "Building \"chromium/\""
mkdir -p .build/chromium
cp -r chromium-src/* .build/chromium/.
ip=1041
;;
1041)
#
# Checking if paragrasp.conf is newer than .build/chromium/manifest.json
#
if [ "`ls -t paragrasp.conf .build/chromium/manifest.json 2> /dev/null | sed 1q`" = "paragrasp.conf" ]; then
  ip=1042
  continue
fi
#
# Checking if chromium-template.json is newer than .build/chromium/manifest.json
#
if [ "`ls -t chromium-template.json .build/chromium/manifest.json 2> /dev/null | sed 1q`" = "chromium-template.json" ]; then
  ip=1042
  continue
fi
#
# Jump
#
ip=1043
continue
#
# Label
#
ip=1042
;;
1042)
echo "Building \"chromium/manifest.json\""
#
# Custom rule
#
python actions/create_manifest_action.py paragrasp.conf chromium-template.json -o .build/chromium/manifest.json
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1043
;;
1043)
#
# Checking if .build/chromium is newer than .build/paragrasp.crx
#
if [ ! -f .build/paragrasp.crx ]; then
  ip=1044
  continue
elif [ "$(find .build/chromium -type f -newer .build/paragrasp.crx)" != "" ]; then
  ip=1044
  continue
fi
#
# Checking if private/chromium.key.pem is newer than .build/paragrasp.crx
#
if [ "`ls -t private/chromium.key.pem .build/paragrasp.crx 2> /dev/null | sed 1q`" = "private/chromium.key.pem" ]; then
  ip=1044
  continue
fi
#
# Jump
#
ip=1045
continue
#
# Label
#
ip=1044
;;
1044)
echo "Building \"paragrasp.crx\""
#
# Custom rule
#
bash actions/package_chrome_extension.sh .build/chromium private/chromium.key.pem -o .build/paragrasp.crx
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1045
;;
1045)
#
# Checking if paragrasp.conf is newer than .build/updates.xml
#
if [ "`ls -t paragrasp.conf .build/updates.xml 2> /dev/null | sed 1q`" = "paragrasp.conf" ]; then
  ip=1046
  continue
fi
#
# Checking if chromium-update-template.xml is newer than .build/updates.xml
#
if [ "`ls -t chromium-update-template.xml .build/updates.xml 2> /dev/null | sed 1q`" = "chromium-update-template.xml" ]; then
  ip=1046
  continue
fi
#
# Jump
#
ip=1047
continue
#
# Label
#
ip=1046
;;
1046)
echo "Building \"updates.xml\""
#
# Custom rule
#
python actions/create_manifest_action.py paragrasp.conf chromium-update-template.xml -o .build/updates.xml
if [ $? -ne 0 ]; then
  ip=1001
  continue
fi
ip=1047
;;
1047)
rm -rf output-result
mkdir output-result
cd output-result
ln ../.build/updates.xml updates.xml
ln ../.build/paragrasp.crx paragrasp.crx
cd ..
echo "Build completed!"
echo "Built output-result/updates.xml"
echo "Built output-result/paragrasp.crx"
echo "Done."
ip=1037
continue
ip=1001
;;
1001)
echo "Failed to build."
ip=1037
;;
1037)
break
;;
esac
done
exit
:
:batch_file
:
set rule=%1
if "%rule%" == "" goto usage
if "%rule%" == "clean" goto clean
if "%rule%" == "package" goto package
if "%rule%" == "clean" goto begin
if "%rule%" == "package" goto begin
if "%rule%" == "chrome-signed" goto begin
if "%rule%" == "jar-signed" goto begin
if "%rule%" == "jar" goto begin
if "%rule%" == "unpacked" goto begin
if "%rule%" == "amo" goto begin
echo Unknown rule: %rule%
echo         Known rules: ['clean', 'package', 'chrome-signed', 'jar-signed', 'jar', 'unpacked', 'amo']
echo.
goto exit
:usage
echo Usage: build.sh.bat ^<rule^>
echo        Known rules: ['clean', 'package', 'chrome-signed', 'jar-signed', 'jar', 'unpacked', 'amo']
echo.
goto exit
:clean
rmdir /s /q .build
rmdir /s /q output-result
echo Cleaned.
echo.
goto exit
:package
echo Not implemented
goto exit
:begin
if not exist .build mkdir .build
:
: Rule needs to be jar,amo,unpacked,jar-signed
:
if "%rule%" == "jar" goto 1003
if "%rule%" == "amo" goto 1003
if "%rule%" == "unpacked" goto 1003
if "%rule%" == "jar-signed" goto 1003
goto 1002
:1003
:
: Checking if js is newer than .build/jar
:
if not exist .build\jar goto 1004
for /F %%a in ('xcopy /L /D /Q /Y /S js\* .build\jar ^| findstr /L /B /V /C:"0 File"') do goto 1004
:
: Jump
:
goto 1005
:
: Label
:
:1004
echo Building "jar/"
if not exist .build\jar mkdir .build\jar
xcopy /e /Y js\* .build\jar
:1005
:1002
:
: Rule needs to be jar,amo,jar-signed
:
if "%rule%" == "jar" goto 1007
if "%rule%" == "amo" goto 1007
if "%rule%" == "jar-signed" goto 1007
goto 1006
:1007
:
: Checking if .build/jar is newer than .build/chrome/paragrasp.jar
:
if not exist .build\chrome\paragrasp.jar goto 1008
for /F %%a in ('xcopy /L /D /Q /Y /S .build\jar\* .build\chrome\paragrasp.jar ^| findstr /L /B /V /C:"0 File"') do goto 1008
:
: Jump
:
goto 1009
:
: Label
:
:1008
echo Building "chrome/paragrasp.jar"
if not exist .build\chrome mkdir .build\chrome
cd .build\jar
7z a -tzip -r -mx=0 ..\chrome\paragrasp.jar *
cd ..\..\
:1009
:
: Checking if paragrasp.conf is newer than .build/chrome.manifest
:
if not exist .build\chrome.manifest goto 1010
for /F %%a in ('xcopy /L /D /Y paragrasp.conf .build\chrome.manifest ^| findstr /L paragrasp.conf') do goto 1010
:
: Checking if firefox-template.manifest is newer than .build/chrome.manifest
:
if not exist .build\chrome.manifest goto 1010
for /F %%a in ('xcopy /L /D /Y firefox-template.manifest .build\chrome.manifest ^| findstr /L firefox-template.manifest') do goto 1010
:
: Jump
:
goto 1011
:
: Label
:
:1010
echo Building "chrome.manifest"
:
: Custom rule
:
python actions/create_manifest_action.py paragrasp.conf firefox-template.manifest -o .build/chrome.manifest -p jar
if ERRORLEVEL 1 goto 1001
:1011
:1006
:
: Rule needs to be amo
:
if not "%rule%" == "amo" goto 1012
:
: Checking if paragrasp.conf is newer than .build/install.rdf
:
if not exist .build\install.rdf goto 1013
for /F %%a in ('xcopy /L /D /Y paragrasp.conf .build\install.rdf ^| findstr /L paragrasp.conf') do goto 1013
:
: Checking if firefox-template.rdf is newer than .build/install.rdf
:
if not exist .build\install.rdf goto 1013
for /F %%a in ('xcopy /L /D /Y firefox-template.rdf .build\install.rdf ^| findstr /L firefox-template.rdf') do goto 1013
:
: Jump
:
goto 1014
:
: Label
:
:1013
echo Building "install.rdf"
:
: Custom rule
:
python actions/create_manifest_action.py paragrasp.conf firefox-template.rdf -o .build/install.rdf -p no_update
if ERRORLEVEL 1 goto 1001
:1014
:1012
:
: Rule needs to be unpacked
:
if not "%rule%" == "unpacked" goto 1015
:
: Checking if .build/jar is newer than .build/chrome/paragrasp
:
if not exist .build\chrome\paragrasp goto 1016
for /F %%a in ('xcopy /L /D /Q /Y /S .build\jar\* .build\chrome\paragrasp ^| findstr /L /B /V /C:"0 File"') do goto 1016
:
: Jump
:
goto 1017
:
: Label
:
:1016
echo Building "chrome/paragrasp/"
if not exist .build\chrome\paragrasp mkdir .build\chrome\paragrasp
xcopy /e /Y .build\jar\* .build\chrome\paragrasp
:1017
:
: Checking if paragrasp.conf is newer than .build/chrome.manifest
:
if not exist .build\chrome.manifest goto 1018
for /F %%a in ('xcopy /L /D /Y paragrasp.conf .build\chrome.manifest ^| findstr /L paragrasp.conf') do goto 1018
:
: Checking if firefox-template.manifest is newer than .build/chrome.manifest
:
if not exist .build\chrome.manifest goto 1018
for /F %%a in ('xcopy /L /D /Y firefox-template.manifest .build\chrome.manifest ^| findstr /L firefox-template.manifest') do goto 1018
:
: Jump
:
goto 1019
:
: Label
:
:1018
echo Building "chrome.manifest"
:
: Custom rule
:
python actions/create_manifest_action.py paragrasp.conf firefox-template.manifest -o .build/chrome.manifest -p unpacked
if ERRORLEVEL 1 goto 1001
:1019
:1015
:
: Rule needs to be jar,unpacked,jar-signed
:
if "%rule%" == "jar" goto 1021
if "%rule%" == "unpacked" goto 1021
if "%rule%" == "jar-signed" goto 1021
goto 1020
:1021
:
: Checking if paragrasp.conf is newer than .build/install.rdf
:
if not exist .build\install.rdf goto 1022
for /F %%a in ('xcopy /L /D /Y paragrasp.conf .build\install.rdf ^| findstr /L paragrasp.conf') do goto 1022
:
: Checking if firefox-template.rdf is newer than .build/install.rdf
:
if not exist .build\install.rdf goto 1022
for /F %%a in ('xcopy /L /D /Y firefox-template.rdf .build\install.rdf ^| findstr /L firefox-template.rdf') do goto 1022
:
: Jump
:
goto 1023
:
: Label
:
:1022
echo Building "install.rdf"
:
: Custom rule
:
python actions/create_manifest_action.py paragrasp.conf firefox-template.rdf -o .build/install.rdf -p jar
if ERRORLEVEL 1 goto 1001
:1023
:1020
:
: Rule needs to be jar,amo,unpacked,jar-signed
:
if "%rule%" == "jar" goto 1025
if "%rule%" == "amo" goto 1025
if "%rule%" == "unpacked" goto 1025
if "%rule%" == "jar-signed" goto 1025
goto 1024
:1025
:
: Checking if preferences/paragrasp.js is newer than .build/defaults/preferences/paragrasp.js
:
if not exist .build\defaults\preferences\paragrasp.js goto 1026
for /F %%a in ('xcopy /L /D /Y preferences\paragrasp.js .build\defaults\preferences\paragrasp.js ^| findstr /L preferences\paragrasp.js') do goto 1026
:
: Jump
:
goto 1027
:
: Label
:
:1026
echo Building "defaults/preferences/paragrasp.js"
if not exist .build\defaults\preferences mkdir .build\defaults\preferences
copy /y preferences\paragrasp.js .build\defaults\preferences\paragrasp.js
:1027
:
: Checking if .build/chrome is newer than .build/paragrasp.xpi
:
if not exist .build\paragrasp.xpi goto 1028
for /F %%a in ('xcopy /L /D /Q /Y /S .build\chrome\* .build\paragrasp.xpi ^| findstr /L /B /V /C:"0 File"') do goto 1028
:
: Checking if .build/chrome.manifest is newer than .build/paragrasp.xpi
:
if not exist .build\paragrasp.xpi goto 1028
for /F %%a in ('xcopy /L /D /Y .build\chrome.manifest .build\paragrasp.xpi ^| findstr /L .build\chrome.manifest') do goto 1028
:
: Checking if .build/defaults is newer than .build/paragrasp.xpi
:
if not exist .build\paragrasp.xpi goto 1028
for /F %%a in ('xcopy /L /D /Q /Y /S .build\defaults\* .build\paragrasp.xpi ^| findstr /L /B /V /C:"0 File"') do goto 1028
:
: Checking if .build/install.rdf is newer than .build/paragrasp.xpi
:
if not exist .build\paragrasp.xpi goto 1028
for /F %%a in ('xcopy /L /D /Y .build\install.rdf .build\paragrasp.xpi ^| findstr /L .build\install.rdf') do goto 1028
:
: Jump
:
goto 1029
:
: Label
:
:1028
echo Building "paragrasp.xpi"
cd .build
7z a -tzip -r -mx=9 paragrasp.xpi chrome\ chrome.manifest defaults\ install.rdf
cd ..
:1029
:1024
:
: Rule needs to be jar,amo,unpacked
:
if "%rule%" == "jar" goto 1031
if "%rule%" == "amo" goto 1031
if "%rule%" == "unpacked" goto 1031
goto 1030
:1031
rmdir /s /q output-result
mkdir output-result
copy .build\paragrasp.xpi output-result\paragrasp.xpi
echo Build completed!
Built output-result\paragrasp.xpi
:1030
:
: Rule needs to be jar-signed
:
if not "%rule%" == "jar-signed" goto 1032
:
: Checking if paragrasp.conf is newer than .build/update-unsigned.rdf
:
if not exist .build\update-unsigned.rdf goto 1033
for /F %%a in ('xcopy /L /D /Y paragrasp.conf .build\update-unsigned.rdf ^| findstr /L paragrasp.conf') do goto 1033
:
: Checking if firefox-update-template.php is newer than .build/update-unsigned.rdf
:
if not exist .build\update-unsigned.rdf goto 1033
for /F %%a in ('xcopy /L /D /Y firefox-update-template.php .build\update-unsigned.rdf ^| findstr /L firefox-update-template.php') do goto 1033
:
: Checking if .build/paragrasp.xpi is newer than .build/update-unsigned.rdf
:
if not exist .build\update-unsigned.rdf goto 1033
for /F %%a in ('xcopy /L /D /Y .build\paragrasp.xpi .build\update-unsigned.rdf ^| findstr /L .build\paragrasp.xpi') do goto 1033
:
: Jump
:
goto 1034
:
: Label
:
:1033
echo Building "update-unsigned.rdf"
:
: Custom rule
:
python actions/create_manifest_action.py paragrasp.conf firefox-update-template.php .build/paragrasp.xpi -o .build/update-unsigned.rdf -p hash
if ERRORLEVEL 1 goto 1001
:1034
:
: Checking if .build/update-unsigned.rdf is newer than .build/update.php
:
if not exist .build\update.php goto 1035
for /F %%a in ('xcopy /L /D /Y .build\update-unsigned.rdf .build\update.php ^| findstr /L .build\update-unsigned.rdf') do goto 1035
:
: Checking if private/firefox.key.db is newer than .build/update.php
:
if not exist .build\update.php goto 1035
for /F %%a in ('xcopy /L /D /Y private\firefox.key.db .build\update.php ^| findstr /L private\firefox.key.db') do goto 1035
:
: Jump
:
goto 1036
:
: Label
:
:1035
echo Building "update.php"
:
: Custom rule
:
python actions/sign_with_mccoy.py .build/update-unsigned.rdf private/firefox.key.db -o .build/update.php
if ERRORLEVEL 1 goto 1001
:1036
rmdir /s /q output-result
mkdir output-result
copy .build\update.php output-result\update.php
copy .build\paragrasp.xpi output-result\paragrasp.xpi
echo Build completed!
Built output-result\update.php
Built output-result\paragrasp.xpi
:1032
:
: Rule needs to be chrome-signed
:
if not "%rule%" == "chrome-signed" goto 1037
:
: Checking if js/content/paragrasp.js is newer than .build/chromium/paragrasp.js
:
if not exist .build\chromium\paragrasp.js goto 1038
for /F %%a in ('xcopy /L /D /Y js\content\paragrasp.js .build\chromium\paragrasp.js ^| findstr /L js\content\paragrasp.js') do goto 1038
:
: Jump
:
goto 1039
:
: Label
:
:1038
echo Building "chromium/paragrasp.js"
if not exist .build\chromium mkdir .build\chromium
copy /y js\content\paragrasp.js .build\chromium\paragrasp.js
:1039
:
: Checking if chromium-src is newer than .build/chromium
:
if not exist .build\chromium goto 1040
for /F %%a in ('xcopy /L /D /Q /Y /S chromium-src\* .build\chromium ^| findstr /L /B /V /C:"0 File"') do goto 1040
:
: Jump
:
goto 1041
:
: Label
:
:1040
echo Building "chromium/"
if not exist .build\chromium mkdir .build\chromium
xcopy /e /Y chromium-src\* .build\chromium
:1041
:
: Checking if paragrasp.conf is newer than .build/chromium/manifest.json
:
if not exist .build\chromium\manifest.json goto 1042
for /F %%a in ('xcopy /L /D /Y paragrasp.conf .build\chromium\manifest.json ^| findstr /L paragrasp.conf') do goto 1042
:
: Checking if chromium-template.json is newer than .build/chromium/manifest.json
:
if not exist .build\chromium\manifest.json goto 1042
for /F %%a in ('xcopy /L /D /Y chromium-template.json .build\chromium\manifest.json ^| findstr /L chromium-template.json') do goto 1042
:
: Jump
:
goto 1043
:
: Label
:
:1042
echo Building "chromium/manifest.json"
:
: Custom rule
:
python actions/create_manifest_action.py paragrasp.conf chromium-template.json -o .build/chromium/manifest.json
if ERRORLEVEL 1 goto 1001
:1043
:
: Checking if .build/chromium is newer than .build/paragrasp.crx
:
if not exist .build\paragrasp.crx goto 1044
for /F %%a in ('xcopy /L /D /Q /Y /S .build\chromium\* .build\paragrasp.crx ^| findstr /L /B /V /C:"0 File"') do goto 1044
:
: Checking if private/chromium.key.pem is newer than .build/paragrasp.crx
:
if not exist .build\paragrasp.crx goto 1044
for /F %%a in ('xcopy /L /D /Y private\chromium.key.pem .build\paragrasp.crx ^| findstr /L private\chromium.key.pem') do goto 1044
:
: Jump
:
goto 1045
:
: Label
:
:1044
echo Building "paragrasp.crx"
:
: Custom rule
:
python actions/package_chrome_extension.sh .build/chromium private/chromium.key.pem -o .build/paragrasp.crx
if ERRORLEVEL 1 goto 1001
:1045
:
: Checking if paragrasp.conf is newer than .build/updates.xml
:
if not exist .build\updates.xml goto 1046
for /F %%a in ('xcopy /L /D /Y paragrasp.conf .build\updates.xml ^| findstr /L paragrasp.conf') do goto 1046
:
: Checking if chromium-update-template.xml is newer than .build/updates.xml
:
if not exist .build\updates.xml goto 1046
for /F %%a in ('xcopy /L /D /Y chromium-update-template.xml .build\updates.xml ^| findstr /L chromium-update-template.xml') do goto 1046
:
: Jump
:
goto 1047
:
: Label
:
:1046
echo Building "updates.xml"
:
: Custom rule
:
python actions/create_manifest_action.py paragrasp.conf chromium-update-template.xml -o .build/updates.xml
if ERRORLEVEL 1 goto 1001
:1047
rmdir /s /q output-result
mkdir output-result
copy .build\updates.xml output-result\updates.xml
copy .build\paragrasp.crx output-result\paragrasp.crx
echo Build completed!
Built output-result\updates.xml
Built output-result\paragrasp.crx
echo Done.
goto 1037
:1001
echo Failed to build.
:1037
echo.
:exit

