/*****************************************************************************
 * Copyright 2008 Dustin Long (dlong@progmatism.com)
 *
 * This file is part of Paragrasp.
 *
 * Paragrasp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Paragrasp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Paragrasp.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/

var g_currentNode = null;
var g_currentStyleBgcolor = null;

function OnKeyDown(event) {
    if (event.keyCode == /* J */ 74 && event.ctrlKey && event.shiftKey) {
        var selection = document.getSelection();
        if (selection.type != "Range") {
            return;
        }

        var node = selection.anchorNode;
        ParagraspCore.JumpToNode(node);
        selection.empty();

        event.preventDefault();
        event.stopPropagation();
        return;
    }
    if (event.keyCode == /* C */ 67 && event.ctrlKey && event.shiftKey) {
        ParagraspCore.ClearHighlight();
        event.preventDefault();
        event.stopPropagation();
        return;
    }
    if (event.keyCode == /* up */ 38 && event.ctrlKey) {
        ParagraspCore.NavigateParagraph(-1);
        event.preventDefault();
        event.stopPropagation();
        return;
    }
    if (event.keyCode == /* down */ 40 && event.ctrlKey) {
        ParagraspCore.NavigateParagraph(1);
        event.preventDefault();
        event.stopPropagation();
        return;
    }
}

function OnMouseScroll(event) {
    if (!ParagraspUtil.HasHighlight()) {
        return;
    }
    if (event.wheelDelta > 0) {
        ParagraspCore.NavigateParagraph(-1);
        event.preventDefault();
        event.stopPropagation();
    } else if (event.wheelDelta < 0) {
        ParagraspCore.NavigateParagraph(1);
        event.preventDefault();
        event.stopPropagation();
    }
}

function OnMouseDown(event) {
    if (event.button != 1) {
        return;
    }
    if (event.ctrlKey == false) {
        return;
    }
    ParagraspCore.JumpToNode(event.target);
    event.preventDefault();
    event.stopPropagation();
}

window.addEventListener("keydown", OnKeyDown, true);

window.addEventListener('mousewheel', function(e) {
    return OnMouseScroll(e)
} , false);

window.addEventListener('mousedown', function(e) {
    return OnMouseDown(e);
} , false);
