/*****************************************************************************
 * Copyright 2008 Dustin Long (dlong@progmatism.com)
 *
 * This file is part of Paragrasp.
 *
 * Paragrasp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Paragrasp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Paragrasp.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/
var ParagraspUtil = {
    m_storage : {},

    RetrieveAdvOpt : function() {
        /* pass */
    },
    GetPrivate : function(name) {
        return this.m_storage[name];
    },
    SetPrivate : function(name, value) {
        this.m_storage[name] = value;
    },
    DocumentRootNode : function() {
        return window.document.firstChild;
    },
    ScrollTopPref : function() {
        return "0";
    },
    ListElemPref : function() {
        return "0";
    },
    ParaHerePref : function() {
        return "0";
    },
    IncShortiesPref : function() {
        return "0";
    },
    NoSpansPref : function() {
        return "0";
    },
    MouseWheelPref : function() {
        return "0";
    },
    HasHighlight : function() {
        if (this.m_storage['hlNodeRange']) {
            return true;
        } else {
            return false;
        }
    },
    CreateElement : function(tagName) {
        return window.document.createElement(tagName);
    },
    CreateTextNode : function(textContent) {
        return window.document.createTextNode(textContent);
    },
    WindowObject : function() {
        return window;
    },
};

var ParagraspShared = {
    getStringPref : function(name) {
        if (name == "paragrasp.color.background") {
            return "#ffff88";
        } else if (name == "paragrasp.color.foreground") {
            return "#000000";
        } else if (name == "paragrasp.scroll.method") {
            return "2";
        } else if (name == "paragrasp.scroll.smooth") {
            return "0";
        }
    },
};
