/*****************************************************************************
 * Copyright 2008 Dustin Long (dlong@progmatism.com)
 *
 * This file is part of Paragrasp.
 *
 * Paragrasp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Paragrasp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Paragrasp.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/
var ParagraspKeyset =
{
    startConfig : function()
    {
	var keyChoiceGroup = document.getElementById("keyChoiceGroup");
	keyChoiceGroup.addEventListener('command', function (e) { ParagraspKeyset.onKeyChoiceGroup_Select(e); }, true);

	var keyChoiceNormalValue  = document.getElementById("keyChoiceNormalValue");
	keyChoiceNormalValue.setAttribute("onchange", "ParagraspKeyset.onKeyChoiceNormalValue_Change();");

	var keyName = window.arguments[0];
	this.setAttributes(keyName);
    },

    finishConfig : function()
    {
	window.arguments[1].value = this.keyValueFromDialog();
	window.close();
    },

    dismissConfig : function()
    {
	window.close();
    },

    keyValueFromDialog : function()
    {
	var build = "";
	if (document.getElementById("key_mod_ctrl").checked)
            build += "control ";
	if (document.getElementById("key_mod_shift").checked)
            build += "shift ";
	if (document.getElementById("key_mod_alt").checked)
            build += "alt ";

	if (build.length > 0)
            build = build.substr(0, build.length - 1);
        
	build += "][";
        
	if (document.getElementById("keyChoiceGroup").selectedIndex == 0)
            build += document.getElementById("keyChoiceNormalValue").value;

	build += "][";

	if (document.getElementById("keyChoiceGroup").selectedIndex == 1)
            build += ParagraspShared.scanCodeOfDropListIndex(document.getElementById("keyChoiceSpecialValue")
							             .selectedIndex);
	return build;
    },

    setAttributes : function(name)
    {
	var keyValue = ParagraspShared.fetchKeyValue(name);

	var settings = keyValue.split("][");

	if (settings[0].indexOf("control") != -1)
            document.getElementById("key_mod_ctrl").checked = true;
	if (settings[0].indexOf("shift") != -1)
            document.getElementById("key_mod_shift").checked = true;
	if (settings[0].indexOf("alt") != -1)
            document.getElementById("key_mod_alt").checked = true;

	if (settings[1] != "")
	{
            this.setKeyChoiceMode(0);
            var keyChoiceNormalValue = document.getElementById("keyChoiceNormalValue");
            keyChoiceNormalValue.value = settings[1];
	}

	if (settings[2] != "")
	{
            this.setKeyChoiceMode(1);
            var keyChoiceSpecialValue = document.getElementById("keyChoiceSpecialValue");
            keyChoiceSpecialValue.selectedIndex = ParagraspShared.dropListIndexOfScanCode(settings[2]);
	}
    },

    onKeyChoiceGroup_Select : function()
    {
	var keyChoiceGroup = document.getElementById("keyChoiceGroup");
	var index = keyChoiceGroup.selectedIndex;
	this.setKeyChoiceMode(index);
    },
    
    setKeyChoiceMode : function(index)
    {
	var keyChoiceGroup = document.getElementById("keyChoiceGroup");
	keyChoiceGroup.selectedIndex = index;

	var keyChoiceNormalValue  = document.getElementById("keyChoiceNormalValue");
	var keyChoiceSpecialValue  = document.getElementById("keyChoiceSpecialValue");

	if (index == 0)
	{
            keyChoiceNormalValue.disabled = false;
            keyChoiceSpecialValue.disabled = true;
	}
	else if (index == 1)
	{
            keyChoiceNormalValue.disabled = true;
            keyChoiceSpecialValue.disabled = false;
	}
    },

    onKeyChoiceNormalValue_Change : function()
    {
	var keyChoiceNormalValue  = document.getElementById("keyChoiceNormalValue");
	keyChoiceNormalValue.value = keyChoiceNormalValue.value.toUpperCase();
    }
};
