/*****************************************************************************
 * Copyright 2008 Dustin Long (dlong@progmatism.com)
 *
 * This file is part of Paragrasp.
 *
 * Paragrasp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * Paragrasp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with Paragrasp.  If not, see <http://www.gnu.org/licenses/>.
 *****************************************************************************/
var ParagraspUtil = {
    m_scrollTopPref : null,
    m_listElemPref : null,
    m_paraHerePref : null,
    m_incShortiesPref : null,
    m_noSpansPref : null,
    m_mouseWheelPref : null,

    RetrieveAdvOpt : function() {
        this.m_scrollTopPref =
            ParagraspShared.getStringPref("paragrasp.advopt.scrollTop");
        this.m_listElemPref =
            ParagraspShared.getStringPref("paragrasp.advopt.listElem");
        this.m_paraHerePref =
            ParagraspShared.getStringPref("paragrasp.advopt.paraHere");
        this.m_incShortiesPref =
            ParagraspShared.getStringPref("paragrasp.advopt.incShorties");
        this.m_noSpansPref =
            ParagraspShared.getStringPref("paragrasp.advopt.noSpans");
        this.m_mouseWheelPref =
            ParagraspShared.getStringPref("paragrasp.scroll.wheel");
    },

    ScrollTopPref : function() {
        return this.m_scrollTopPref;
    },

    ListElemPref : function() {
        return this.m_listElemPref;
    },

    ParaHerePref : function() {
        return this.m_paraHerePref;
    },

    IncShortiesPref : function() {
        return this.m_incShortiesPref;
    },

    NoSpansPref : function() {
        return this.m_noSpansPref;
    },

    MouseWheelPref : function() {
        return this.m_mouseWheelPref;
    },

    GetFocusedWin : function() {
        var focused = document.commandDispatcher.focusedWindow;
        return focused;
    },

    GetCurrentTab : function() {
        var current = this.GetFocusedWin();
        if (current.wrappedJSObject) {
            return current.wrappedJSObject;
        }
        else {
            return focused;
        }
    },

    GetPrivate : function(property) {
        var win = this.GetFocusedWin();
        if (property == "oldColors") {
            return win.m_oldColors;
        }
        if (property == "hlNodeRange") {
            return win.m_hlNodeRange;
        }
        throw "Error: Get " + property;
    },

    SetPrivate : function(property, value) {
        var win = this.GetFocusedWin();
        if (property == "oldColors") {
            win.m_oldColors = value; return;
        }
        if (property == "hlNodeRange") {
            win.m_hlNodeRange = value; return;
        }
        throw "Error: Set " + property;
    },

    CreateElement : function(tagName) {
        return this.GetCurrentTab().document.createElement(tagName);
    },

    CreateTextNode : function(textContent) {
        return this.GetCurrentTab().document.createTextNode(textContent);
    },

    DocumentRootNode : function() {
        var currWin = this.GetCurrentTab();
        return currWin.document.firstChild;
    },

    WindowObject : function() {
        return this.GetCurrentTab();
    },
};
