
var DocumentLoader =
{
    m_focusedWindow : null,

    setCurrent : function(path)
    {
        var doc = this.load(path);
        this.m_focusedWindow = new Object();
        this.m_focusedWindow.document = doc;
        document = doc; 
    },

    focusedWindowFunc : function()
    {
        if (this.m_focusedWindow == null)
        {
            throw "Never set current document!";
        }
        var self = this;
        return function() { return self.m_focusedWindow; };
    },

    load : function(path)
    {
        var file = Components.classes["@mozilla.org/file/directory_service;1"]
                              .getService(Components.interfaces.nsIProperties)
                              .get("CurWorkD", Components.interfaces.nsIFile);

        file.append(path);
        if (!file.exists())
        {
            dump("[" + file.path + "]\n");
            throw "file not exist\n";
        }
        else
        {
            var inStream = this.getReadStream(file);
            text = this.readContents(inStream);
        }
    
        var domParser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
                        .createInstance(Components.interfaces.nsIDOMParser);
        var doc = domParser.parseFromString(text, "application/xhtml+xml");
        return doc;
    },

    getReadStream : function(file)
    {
        var stream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                               .createInstance(Components.interfaces.nsIFileInputStream);
        stream.init(file, 0x01 /*PR_RDONLY*/, 0660, 4 /*CLOSE_ON_EOF*/);
        return stream;
    },

    readContents : function(stream)
    {
        var scriptable = Components.classes["@mozilla.org/scriptableinputstream;1"]
                                   .getService(Components.interfaces.nsIScriptableInputStream);
        scriptable.init(stream);
        var contents = scriptable.read(scriptable.available());
        return contents;
    }
}; 
