
load("framework.js"); 
load("../js/content/paragrasp.js");

TestSuite.test_maxMin = function()
{
    assert(ParagraspGlobal.min(5,9) == 5);
    assert(ParagraspGlobal.min(8,4) == 4);
    assert(ParagraspGlobal.min(6,6) == 6);
    assert(ParagraspGlobal.min(-2,0) == -2);
    assert(ParagraspGlobal.max(1,9) == 9);
    assert(ParagraspGlobal.max(-3,-4) == -3);
    assert(ParagraspGlobal.max(-7,8) == 8);
    assert(ParagraspGlobal.max(4,2) == 4);
    assert(ParagraspGlobal.max(5,5) == 5);
}

TestSuite.test_firstLastElement = function()
{
    var elems = [ 1, 2, 3, 4, 5 ];
    assert(ParagraspGlobal.firstElement(elems) == 1);
    assert(ParagraspGlobal.lastElement(elems)  == 5);
    var elems = [ 7 ];
    assert(ParagraspGlobal.firstElement(elems) ==
           ParagraspGlobal.lastElement(elems));
}

load("load_doc.js");

TestSuite.test_textContent = function()
{
    DocumentLoader.setCurrent("simple_page.html");
    var paras = document.getElementsByTagName("p");
    var p = paras.item(0);
    if (p.textContent)
    {
        print("*** para content [" + p.textContent + "]");
    }
    else
    {
        print("*** para does not have textContent");
    }
}

TestSuite.test_simplePage = function()
{
    DocumentLoader.setCurrent("simple_page.html");

    ParagraspGlobal.GetFocusedWindow = DocumentLoader.focusedWindowFunc();
    ParagraspGlobal.VisibleRange = function(a) { return true; }

    var range;
    range = ParagraspGlobal.DefaultNodeRange();
    ParagraspGlobal.m_traveling = false;
    range = ParagraspGlobal.TravelForwardParagraph(ParagraspGlobal.lastElement(range));
    assert(rangeData(range) == "Paragraph one is right here.");
    range = ParagraspGlobal.TravelForwardParagraph(ParagraspGlobal.lastElement(range));
    assert(rangeData(range) == "Another starts right at this point.");
    range = ParagraspGlobal.TravelForwardParagraph(ParagraspGlobal.lastElement(range));
    assert(rangeData(range) == "And then an epic conclusion");
    range = ParagraspGlobal.TravelForwardParagraph(ParagraspGlobal.lastElement(range));
    assert(rangeData(range) == "The end. It's all over now");
}

TestSuite.run_all_tests();

